apoyos/urls.py
from django.urls import path
from .views import ApoyosView, LocalidadView, LocalidadNew, LocalidadEdit, LocalidadDelete, \
    PersonaView, PersonaNew, PersonaEdit, PersonaDelete, personas_por_comunidad, getActivistas, getActivados, \
    EncargadoRutaView, EncargadoRutaNew, EncargadoRutaEdit, EncargadoRutaDelete, comunidades_por_encargado, \
    PuestoView, PuestoNew, PuestoEdit, PuestoDelete, \
    DepartamentoView, DepartamentoNew, DepartamentoEdit, DepartamentoDelete, \
    EmpleadoView, EmpleadoNew, EmpleadoEdit, EmpleadoDelete, empleados_por_departamento, empleados_por_puesto, \
    ApoyosView, ApoyosNew, ApoyosEdit, ApoyosDelete, apoyos_por_persona, agregarApoyos, busqueda_de_personas

urlpatterns = [
    # crud localidades
    path('localidades/', LocalidadView.as_view(), name='localidades_list'),
    path('localidades/new', LocalidadNew.as_view(), name='localidades_new'),
    path('localidades/edit/<int:pk>', LocalidadEdit.as_view(), name='localidades_edit'),
    path('localidades/delete/<int:pk>', LocalidadDelete.as_view(), name='localidades_delete'),
    
    # crud personas
    path('personas/', PersonaView.as_view(), name='personas_list'),
    path('personas/new', PersonaNew.as_view(), name='personas_new'),
    path('personas/edit/<int:pk>', PersonaEdit.as_view(), name='personas_edit'),
    path('personas/delete/<int:pk>', PersonaDelete.as_view(), name="personas_delete"),
    
    # búsqueda de personas
    path('personas/busqueda', busqueda_de_personas, name='busqueda'),
    
    # búsqueda de persona por CURP
    # path('personas/buscar/<str:curp>', busqueda_de_persona_por_curp, name='buscar_persona'),
    
    # ver activistas
    path('personas/activistas', getActivistas, name='activistas_list'),
    # ver activados
    path('personas/activados', getActivados, name='activados_list'),
    
    # personas de cada comunidad
    path('personas/personas-por-comunidad/<int:id>', personas_por_comunidad, name='personas_por_comunidad'),
    
    # crud de encargados de ruta
    path('encargados-ruta/', EncargadoRutaView.as_view(), name='encargados_list'),
    path('encargados-ruta/new', EncargadoRutaNew.as_view(), name='encargados_new'),
    path('encargados-ruta/edit/<int:pk>', EncargadoRutaEdit.as_view(), name='encargados_edit'),
    path('encargados-ruta/delete/<int:pk>', EncargadoRutaDelete.as_view(), name="encargados_delete"),
    
    # comunidadaes que dirige cada encargado de ruta
    path('encargados-ruta/comunidades-er/<int:id>', comunidades_por_encargado, name='comunidades-er'),    
    
    # crud de puestos
    path('puestos/', PuestoView.as_view(), name='puestos_list'),
    path('puestos/new', PuestoNew.as_view(), name='puestos_new'),
    path('puestos/edit/<int:pk>', PuestoEdit.as_view(), name='puestos_edit'),
    path('puestos/delete/<int:pk>', PuestoDelete.as_view(), name='puestos_delete'),
    
    # crud de departamentos
    path('departamentos/', DepartamentoView.as_view(), name='departamentos_list'),
    path('departamentos/new', DepartamentoNew.as_view(), name='departamentos_new'),
    path('departamentos/edit/<int:pk>', DepartamentoEdit.as_view(), name='departamentos_edit'),
    path('departamentos/delete/<int:pk>', DepartamentoDelete.as_view(), name='departamentos_delete'),
    
    # crud de empleados
    path('empleados/', EmpleadoView.as_view(), name='empleados_list'),
    path('empleados/new', EmpleadoNew.as_view(), name='empleados_new'),
    path('empleados/edit/<int:pk>', EmpleadoEdit.as_view(), name='empleados_edit'),
    path('empleados/delete/<int:pk>', EmpleadoDelete.as_view(), name='empleados_delete'),
    
    # empleados de cada departamento
    path('empleados/empleados-por-departamento/<int:id>', empleados_por_departamento, name='empleados_por_departamento'),
    # empleados de cada puesto
    path('empleados/empleados-por-puesto/<int:id>', empleados_por_puesto, name='empleados_por_puesto'),
    
    # crud de apoyos
    path('apoyos/', ApoyosView.as_view(), name='apoyos_list'),
    path('apoyos/new', ApoyosNew.as_view(), name='apoyos_new'),
    path('apoyos/edit/<int:pk>', ApoyosEdit.as_view(), name='apoyos_edit'),
    path('apoyos/delete/<int:pk>', ApoyosDelete.as_view(), name='apoyos_delete'),
    
    # agregar apoyo
    path('apoyos/agregar-apoyo/<int:id>', agregarApoyos, name='agregar_apoyos'),
    
    # apoyos que ha recibido cada persona
    path('apoyos/apoyos-recibidos/<int:id>', apoyos_por_persona, name='apoyos-recibidos'),
        
]

bases/urls.py
from django.urls import path
from django.contrib.auth import views as auth_views

from bases.views import Home, HomeSinPrivilegios, getEstadisticas

urlpatterns = [
    path('', Home.as_view(), name='home'),
    path('login/', auth_views.LoginView.as_view(template_name='bases/login.html'), name='login'),
    path('logout/', auth_views.LogoutView.as_view(template_name='bases/login.html'), name='logout'),
    path('sin_privilegios/', HomeSinPrivilegios.as_view(), name="sin_privilegios"),
    path('bases/obtener-estadisticas/', getEstadisticas, name="obtener-estadisticas")
]

catastro/urls.py
from django.urls import path
from .views import ContribuyenteView, ContribuyenteNew, ContribuyenteEdit, ContribuyenteDelete, \
    busqueda_por_cuenta_predial

urlpatterns = [
    # crud de contribuyentes
    path('contribuyentes/', ContribuyenteView.as_view(), name='contribuyentes_list'),
    path('contribuyentes/new', ContribuyenteNew.as_view(), name='contribuyentes_new'),
    path('contribuyentes/edit/<int:pk>', ContribuyenteEdit.as_view(), name='contribuyentes_edit'),
    path('contribuyentes/delete/<int:pk>', ContribuyenteDelete.as_view(), name='contribuyentes_delete'),
    
    # búsqueda de contribuyentes 
    path('contribuyentes/busqueda', busqueda_por_cuenta_predial, name='busqueda'),
    # path('contribuyentes/buscar/<int:id_cuenta>', busqueda_por_cuenta_predial, name='buscar_contribuyente'),
]

gestion_apoyos/urls.py
from argparse import Namespace
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('', include(('bases.urls', 'bases'), namespace='bases')),
    path('apoyos/', include(('apoyos.urls', 'apoyos'), namespace='apoyos')),
    path('catastro/', include(('catastro.urls', 'catastro'), namespace='catastro')),
    path('admin/', admin.site.urls),
]

urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

bases/models.py
from django.db import models

# Create your models here.

    

bases/views.py
from django.contrib.auth.mixins import LoginRequiredMixin
from django.views import generic
from logging import raiseExceptions
from django.http import HttpResponseRedirect
from django.urls import reverse_lazy
from django.contrib.auth.mixins import LoginRequiredMixin, PermissionRequiredMixin
from django.contrib.messages.views import SuccessMessageMixin
from django.views.generic.base import TemplateView
from django.contrib import messages
from django.shortcuts import render, redirect
from apoyos.models import Persona, Apoyos, EncargadoRuta, Empleado, Departamento, Localidad, Puesto
from catastro.models import Contribuyente

# Create your views here.
class Sin_Privilegios(LoginRequiredMixin, PermissionRequiredMixin):
    login_url = 'bases:login'
    raiseExceptions = False # no se ponga la pantalla en blanco
    redirect_field_name = "redirect_to"

    def handle_no_permission(self):
        """ método que valida si el usuario tiene privilegios, para redireccionar a plantilla"""
        from django.contrib.auth.models import AnonymousUser

        # si el usuario es válido, se muestra la vista sin privilegios
        if not self.request.user == AnonymousUser():
            self.login_url = "bases:sin_privilegios"

        return HttpResponseRedirect(reverse_lazy(self.login_url))
    
class Home(LoginRequiredMixin, TemplateView):    
    template_name = 'bases/home.html'
    login_url = 'bases:login' # sino esta logeado se redireccona al admin

class HomeSinPrivilegios(LoginRequiredMixin, generic.TemplateView):
    login_url = 'bases:login'
    template_name = "bases/sin_privilegios.html"
    
def getEstadisticas(request):
    """ mostrar todos los activistas"""
    # total de activistas
    activistas = Persona.objects.all().filter(tipo="ACTIVISTA").count()
    # print(activistas)
    
    # total de activados
    activados = Persona.objects.all().filter(tipo="ACTIVADO").count()
    # print(activados)
    
    # total de apoyos entregados
    apoyos = Apoyos.objects.all().count()
    # total de encargados de ruta
    encargados = EncargadoRuta.objects.all().count()
    # total de empleados
    empleados = Empleado.objects.all().count()
    # total de departamentos
    departamentos = Departamento.objects.all().count()
    # total de localidades
    localidades = Localidad.objects.all().count()
    # total de puestos
    puestos = Puesto.objects.all().count()
    
    # total de contribuyentes
    contribuyentes = Contribuyente.objects.all().count()
    
    template_name = "bases/home.html"
    context = {
        'activistas': activistas,
        'activados': activados,
        'apoyos': apoyos,
        'encargados': encargados,
        'empleados': empleados,
        'departamentos': departamentos,
        'localidades': localidades,
        'contribuyentes': contribuyentes
    }
    
    return render(request, template_name, context)

bases/templates/bases/home.html
{% extends 'base/base.html' %}

{% load static %}

<!-- sobreescribimos el bloque de contenido principal -->
{% block page_content %}
    <div class="container-fluid">
        
        <!-- Page Heading -->
        <div class="d-sm-flex align-items-center justify-content-between mb-4">
            <h1 class="h3 mb-0 text-gray-800">Información General</h1>
            <!-- <a href="#" class="d-none d-sm-inline-block btn btn-sm btn-primary shadow-sm"><i
                class="fas fa-home fa-sm text-white-50"></i>Contribuyentes</a> -->
            <a href="{% url 'catastro:contribuyentes_list' %}" class="btn btn-danger btn-icon-split btn-sm">
                <span class="icon text-white-50">
                    <i class="fas fa-list"></i>
                </span>
                <span class="text">Ver contribuyentes</span>
            </a>
        </div>

        <div class="row">

            <div class="col-md-6">
                <!-- Illustrations -->
                <div class="card shadow mb-4">
                    <div class="card-header py-3">
                        <h6 class="m-0 font-weight-bold text-black-50">Administración de Recursos Entregados</h6>
                    </div>
                    <div class="card-body">
                        <div class="text-center">
                            <img class="img-fluid px-3 px-sm-4 mt-3 mb-4" style="width: 25rem; height: 15rem;"
                                src="{% static 'base/img/apoyos-pinos-zac.svg' %}" alt="Información de activistas/activados">
                        </div>
                        <p>El sistema de gestión de apoyos administra una base de datos global, de <a
                                target="_blank" rel="nofollow" href="#">Pinos, Zac</a>, dónde
                            concentra a todos los activistas y activados; con la finalidad de saber que apoyos han recibido; así
                            como cuales están activos y cuáles no.</p>

                            <div class="row">                                
                                <div class="col-md-6">
                                    <a href="{% url 'apoyos:personas_list' %}" class="btn btn-secondary btn-icon-split">
                                        <span class="icon text-white-50">
                                            <i class="fas fa-user"></i>
                                        </span>
                                        <span class="text">Ver personas</span>
                                    </a>
                                </div>

                                <div class="col-md-6">
                                    <a href="{% url 'apoyos:apoyos_list' %}" class="btn btn-secondary btn-icon-split">
                                        <span class="icon text-white-50">
                                            <i class="fas fa-box-open"></i>
                                        </span>
                                        <span class="text">Ver Apoyos</span>
                                    </a>
                                </div>
                            </div>
                    </div>
                </div>
            </div>

            <div class="col-md-6">
                <!-- Illustrations -->
                <div class="card shadow mb-4">
                    <div class="card-header py-3">
                        <h6 class="m-0 font-weight-bold text-black-50">Administración de personal</h6>
                    </div>
                    <div class="card-body">
                        <div class="text-center">
                            <img class="img-fluid px-3 px-sm-4 mt-3 mb-4" style="width: 25rem; height: 15rem;"
                                src="{% static 'base/img/personas-admon.svg' %}" alt="...">
                        </div>
                        <p>El sistema contempla un apartado dónde se puede ubicar la información general de cada<a
                                target="_blank" rel="nofollow" href="#">Empleado</a>, que esta
                            trabajando en la presidencia municipal y la función que desempeña; todo esto con fines informativos
                            y para llevar un control del personal activo.</p>
                            <a href="{% url 'apoyos:empleados_list' %}" class="btn btn-secondary btn-icon-split">
                                <span class="icon text-white-50">
                                    <i class="fas fa-user-alt-slash"></i>
                                </span>
                                <span class="text">Ver empleados</span>
                            </a>
                    </div>
                </div>
            </div>


        </div>

        <!-- Content Row -->
        <div class="row">
            
            <!-- Earnings (Monthly) Card Example -->
            <div class="col-xl-3 col-md-6 mb-4">
                <div class="card border-left-primary shadow h-100 py-2">
                    <div class="card-body">
                        <div class="row no-gutters align-items-center">
                            <div class="col mr-2">
                                <div class="text-xs font-weight-bold text-primary text-uppercase mb-1">
                                    Activistas</div>
                                <div class="h5 mb-0 font-weight-bold text-gray-800">
                                    {{ activistas }}
                                </div>
                            </div>
                            <div class="col-auto">
                                <i class="fas fa-user-alt fa-2x text-gray-300"></i>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <!-- Earnings (Monthly) Card Example -->
            <div class="col-xl-3 col-md-6 mb-4">
                <div class="card border-left-success shadow h-100 py-2">
                    <div class="card-body">
                        <div class="row no-gutters align-items-center">
                            <div class="col mr-2">
                                <div class="text-xs font-weight-bold text-success text-uppercase mb-1">
                                    Activados</div>
                                <div class="h5 mb-0 font-weight-bold text-gray-800">{{ activados }}</div>
                            </div>
                            <div class="col-auto">
                                <i class="fas fa-user-alt-slash fa-2x text-gray-300"></i>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <!-- Earnings (Monthly) Card Example -->
            <div class="col-xl-3 col-md-6 mb-4">
                <div class="card border-left-info shadow h-100 py-2">
                    <div class="card-body">
                        <div class="row no-gutters align-items-center">
                            <div class="col mr-2">
                                <div class="text-xs font-weight-bold text-info text-uppercase mb-1">Apoyos Entregados
                                </div>
                                <div class="row no-gutters align-items-center">
                                    <div class="col-auto">
                                        <div class="h5 mb-0 mr-3 font-weight-bold text-gray-800">{{ apoyos }}</div>
                                    </div>
                                    <div class="col">
                                        <div class="progress progress-sm mr-2">
                                            <div class="progress-bar bg-info" role="progressbar"
                                                style="width: 50%" aria-valuenow="50" aria-valuemin="0"
                                                aria-valuemax="100"></div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="col-auto">
                                <i class="fas fa-clipboard-list fa-2x text-gray-300"></i>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <!-- Pending Requests Card Example -->
            <div class="col-xl-3 col-md-6 mb-4">
                <div class="card border-left-warning shadow h-100 py-2">
                    <div class="card-body">
                        <div class="row no-gutters align-items-center">
                            <div class="col mr-2">
                                <div class="text-xs font-weight-bold text-warning text-uppercase mb-1">
                                    Encargados de Ruta</div>
                                <div class="h5 mb-0 font-weight-bold text-gray-800">{{ encargados }}</div>
                            </div>
                            <div class="col-auto">
                                <i class="fas fa-person-booth fa-2x text-gray-300"></i>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <!-- admin de personal -->
        <div class="row">

            <!-- Earnings (Monthly) Card Example -->
            <div class="col-xl-3 col-md-6 mb-4">
                <div class="card border-left-primary shadow h-100 py-2">
                    <div class="card-body">
                        <div class="row no-gutters align-items-center">
                            <div class="col mr-2">
                                <div class="text-xs font-weight-bold text-primary text-uppercase mb-1">
                                    Empleados</div>
                                <div class="h5 mb-0 font-weight-bold text-gray-800">{{ empleados }}</div>
                            </div>
                            <div class="col-auto">
                                <i class="fas fa-user-edit fa-2x text-gray-300"></i>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            
            <!-- Earnings (Monthly) Card Example -->
            <div class="col-xl-3 col-md-6 mb-4">
                <div class="card border-left-success shadow h-100 py-2">
                    <div class="card-body">
                        <div class="row no-gutters align-items-center">
                            <div class="col mr-2">
                                <div class="text-xs font-weight-bold text-success text-uppercase mb-1">
                                    Localidades</div>
                                <div class="h5 mb-0 font-weight-bold text-gray-800">{{ localidades }}</div>
                            </div>
                            <div class="col-auto">
                                <i class="fas fa-house-user fa-2x text-gray-300"></i>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <!-- Earnings (Monthly) Card Example -->
            <div class="col-xl-3 col-md-6 mb-4">
                <div class="card border-left-info shadow h-100 py-2">
                    <div class="card-body">
                        <div class="row no-gutters align-items-center">
                            <div class="col mr-2">
                                <div class="text-xs font-weight-bold text-info text-uppercase mb-1">Departamentos
                                </div>
                                <div class="row no-gutters align-items-center">
                                    <div class="col-auto">
                                        <div class="h5 mb-0 mr-3 font-weight-bold text-gray-800">{{ departamentos }}</div>
                                    </div>                                    
                                </div>
                            </div>
                            <div class="col-auto">
                                <i class="fas fa-building fa-2x text-gray-300"></i>
                            </div>
                        </div>
                    </div>
                </div>
            </div>  

            <!-- Pending Requests Card Example -->
            <div class="col-xl-3 col-md-6 mb-4">
                <div class="card border-left-warning shadow h-100 py-2">
                    <div class="card-body">
                        <div class="row no-gutters align-items-center">
                            <div class="col mr-2">
                                <div class="text-xs font-weight-bold text-warning text-uppercase mb-1">
                                    Contribuyentes</div>
                                <div class="h5 mb-0 font-weight-bold text-gray-800">{{ contribuyentes }}</div>
                            </div>
                            <div class="col-auto">
                                <i class="fas fa-user-tie fa-2x text-gray-300"></i>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>   

    </div>

{% endblock page_content %}    

bases/templates/bases/login.html
{% extends 'base/base.html' %}

{% block side_bar %}{% endblock side_bar %}    
{% block top_bar %}{% endblock top_bar %}
{% block page_content %}{% endblock page_content %}    
{% block footer %}{% endblock footer %}

{% block login %}
<div class="container">

    <!-- Outer Row -->
    <div class="row justify-content-center">

        <div class="col-xl-10 col-lg-12 col-md-9">

            <div class="card o-hidden border-0 shadow-lg my-5">
                <div class="card-body p-0">
                    <!-- Nested Row within Card Body -->
                    <div class="row">
                        <div class="col-lg-6 d-none d-lg-block bg-login-image"></div>
                        <div class="col-lg-6">
                            <div class="p-5">
                                <div class="text-center">
                                    <h1 class="h4 text-gray-900 mb-4">Bienvenido al Sistema!</h1>
                                    <small class="text-danger">
                                                                                                                                                                 
                                    </small>
                                </div>
                                <form class="user" method="post">
                                    {% csrf_token %}
                                    <div class="form-group">
                                        <input type="text" class="form-control form-control-user" id="id_username" name="username"
                                        aria-describedby="emailHelp" placeholder="Ingresa un correo electrónico..">
                                    </div>

                                    <div class="form-group">
                                        <input type="password" class="form-control form-control-user" id="id_password" name="password"
                                        autocomplete="current-password" placeholder="Ingresa tu contraseña..">
                                    </div>
                                    
                                    <!-- {{ form.as_p }} -->

                                    <button type="submit" class="btn btn-secondary btn-user btn-block font-weight-bold text-capitalize">Acceder</button>
                                    
                                    <!-- <div class="my-3">
                                        <span>No tienes cuenta? <a href="#">Registrate</a></span><br>
                                        <span><a href="#">Recuperar password</a></span>
                                    </div> -->
                                </form>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

        </div>

    </div>
{% endblock login %}

{% block js_page %}
    <script>
        {% if form.errors %}
            //si el formulario tiene errores
            {% for field in form %}
                {% if field.errors %}
                    {% for error in field.errors %}
                        mensaje('{{ error|escape }}', 'red')
                    {% endfor %}
                {% endif %}
            {% endfor %}
        {% endif %}


        {% if form.non_field_errors %}
            {% for error in form.non_field_errors %}
                mensaje('{{ error|escape }}', 'red')
            {% endfor %}
        {% endif %}
    </script>
{% endblock js_page %}
    
    

bases/templates/bases/sin_privilegios.html
{% extends 'base/base.html' %}

{% block page_content %}
    <div class="col-xl-6 col-md-6 mb-6">
        <div class="card border-left-danger shadow h-100 py-2">
            <div class="card-body">
                <div class="row no-gutters align-items-center">
                    <div class="col mr-2">
                        <div class="text-xs font-weight-bold text-primary text-uppercase mb-1">
                            USUARIO: <mark> {{ user.username }} {{ user.get_full_name }}</mark>
                        </div>
                        <div class="dropdown-divider"></div>

                        <div class="row">
                            <mark>No tiene suficientes privilegios</mark> para cargar la opción solicitada.
                            <br>
                            <small>Para poder acceder, debe logearse con un usuario con privilegios necesarios.</small>
                        </div>

                        <div class="dropdown-divider"></div>

                        <div class="row">
                            <div class="col">
                                <a href="{% url 'bases:home' %}" class="btn btn-success"><span class="fa fa-home">Ir a Inicio</span></a>
                                <a href="{% url 'bases:login' %}" class="btn btn-success"><span class="fa fa-user">Ingresar con otro usuario</span></a>
                            </div>
                        </div>
                    </div>

                    <div class="col-auto">
                        <i class="far fa-calendar-plus fa-2x text-gray-300"></i>
                    </div>
                </div>
            </div>
        </div>
    </div>
{% endblock page_content %}
    